<?php

namespace App;

use DB;
use Closure;

// App/Notification.php 참고함.
// V0.1 -- 2017-09-30
class Alrimi
{
    public function alrim_insert($alrimModel, $alrimId)
    {
        // 알림은 생성한다.
        $alrimBoard = $alrimModel->board; // 게시판 설정
        $alrimComment = $alrimModel->find($alrimId);
        $alrimParent = $alrimComment->id == $alrimComment->parent ? $alrimComment : $alrimModel->find($alrimComment->parent);
        $alrimLinkBefore = route('board.view', ['boardId' => $alrimBoard->table_name, 'writeId' => $alrimParent->id]);
        $alrimLink = $alrimLinkBefore. '#comment'. $alrimId;
        $alrimContent = '['. $alrimBoard->subject. ']'. $alrimParent->subject. ' 게시물에서 새 댓글이 올라왔습니다.';

        DB::insert('INSERT INTO laon_alrimi(users_id, link, content, read_at) VALUES(?, ?, ?, ?)', array($alrimParent->email, $alrimLink, $alrimContent, 0));
    }

    public function handle($request, Closure $next)
    {
        // 변수 설정
        $alrimLink = array();
        $alrimContent = array();
        $alrimId = array();
        if (auth()->check()) {
            // 알림 받아오기.
            $results = DB::select('SELECT * FROM laon_alrimi WHERE users_id = (?) AND read_at = 0', array(auth()->user()->email));
            foreach ($results as $result) {
                $alrimLink[] = $result->link;
                $alrimContent[] = $result->content;
                $alrimId[] = $result->id;
            }
            $compact = compact(
                'alrimLink', 'alrimContent'
            );
            view()->share($compact);

            // 읽은 알림 처리하기.
            for ($i = 0; $i < count($alrimLink); $i++) {
                if ($request->fullUrl() == $alrimLink[$i]) {
                    // 접속한 주소와, 알림 주소가 같다면 읽음 처리.
                    $alrimRead = DB::update('UPDATE laon_alrimi set read_at = 1 WHERE link = ? AND users_id = ?', array($alrimLink[$i], auth()->user()->email));
                }
            }
        }
        return $next($request);
    }
}
